// util.c
void correct_underflow (VidStream *vid_stream);
int next_bits (int num , unsigned int mask, VidStream *vid_stream);
char *get_ext_data (VidStream *vid_stream);
int next_start_code (VidStream *vid_stream);
char *get_extra_bit_info (VidStream *vid_stream);

// video.c
void init_stats (void );
void PrintAllStats (void);
double ReadSysClock (void);
void PrintTimeInfo (VidStream *vid_stream);
void InitCrop (void);
VidStream *NewVidStream (unsigned int buffer_len);
void DestroyVidStream (VidStream *astream, XInfo *xinfo);
PictImage *NewPictImage (VidStream *vid_stream);
void DestroyPictImage (PictImage *apictimage);
VidStream *mpegVidRsrc (TimeStamp time_stamp, VidStream *vid_stream, int first, XInfo *xinfo);
void SetBFlag (BOOLEAN val);
void SetPFlag (BOOLEAN val);

// parseblock.c
void ParseReconBlock (int n, VidStream *vid_stream);
void ParseAwayBlock (int n, VidStream *vid_stream);

// motionvector.c
void ComputeForwVector (int *recon_right_for_ptr, int *recon_down_for_ptr, VidStream *the_stream);
void ComputeBackVector (int *recon_right_back_ptr, int *recon_down_back_ptr, VidStream *the_stream);

// decoders.c
void init_tables (void);
void decodeDCTDCSizeLum (unsigned int *value);
void decodeDCTDCSizeChrom (unsigned int *value);
void decodeDCTCoeffFirst (unsigned int *run, int *level);
void decodeDCTCoeffNext (unsigned int *run, int *level);

// main.c
int main (int argc, char **argv);
void DoDitherImage (VidStream *vid_stream);

// gdith.c
void InitColorDisplay (XInfo *xinfo);
void ExecuteDisplay (VidStream *vid_stream, XInfo *xinfo);
void ExecutePPM (VidStream *vid_stream);
#ifdef NO_GETTIMEOFDAY
struct timeval {long tv_sec, tv_usec;}; /* secs and usecs since 1-jan-1970 */
int gettimeofday P((struct timeval * retval, void * unused));
#endif

// gray.c
void Gray32DitherImage (unsigned char *lum , unsigned char *cr , unsigned char *cb , unsigned char *out , int h , int w);

// jrevdct.c
void init_pre_idct (void );
void j_rev_dct_sparse (DCTBLOCK data , int pos );
void j_rev_dct (DCTBLOCK data );
void j_rev_dct_sparse (DCTBLOCK data , int pos );
void j_rev_dct (DCTBLOCK data );

// floatdct.c
void init_float_idct (void );
void float_idct (short* block );

// 16bit.c
void InitColorDither (int );
void Color32DitherImage (unsigned char *lum , unsigned char *cr , unsigned char *cb , unsigned char *out , int rows , int cols);

// readfile.c
void SeekStream (VidStream *vid_stream );
void clear_data_stream ( VidStream *vid_stream);
int get_more_data ( VidStream *vid_stream );
int pure_get_more_data (unsigned int *buf_start , int max_length , int *length_ptr , unsigned int **buf_ptr, VidStream *vid_stream);
int read_sys (VidStream *vid_stream, unsigned int start);
int ReadStartCode ( unsigned int *startCode, VidStream *vid_stream);
int ReadPackHeader (double *systemClockTime, unsigned long *muxRate,VidStream *vid_stream);
int ReadSystemHeader ( VidStream *vid_stream);
int find_start_code (FILE *input);
int ReadPacket ( unsigned char packetID, VidStream *vid_stream);
void ReadTimeStamp ( unsigned char *inputBuffer, unsigned char *hiBit, unsigned long *low4Bytes);
void ReadSTD (unsigned char *inputBuffer, unsigned char *stdBufferScale, unsigned long *stdBufferSize);
void ReadRate (unsigned char *inputBuffer, unsigned long *rate);
int MakeFloatClockTime (unsigned char hiBit, unsigned long low4Bytes, double *floatClockTime);
